## net.sf.saxon.instruct
Class InstructionDetails

    java.lang.Object
      net.sf.saxon.instruct.InstructionDetails

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, InstructionInfo, InstructionInfoProvider, Locator

    public final class InstructionDetails

extends Object
implements InstructionInfo, InstructionInfoProvider, Serializable

Details about an instruction, used when reporting errors and when tracing

See Also:
  Serialized Form

Constructor Summary
`InstructionDetails()`

Method Summary
`int` `getColumnNumber()` Get the column number identifying the position of the instruction.
`int` `getConstructType()` Get the construct type
`InstructionInfo` `getInstructionInfo()` Get the InstructionInfo details about the construct.
`int` `getLineNumber()` Get the line number of the instruction within its module
`int` `getLineNumber(int locationId)` Get the line number within the document or module containing a particular location
`NamespaceResolver` `getNamespaceResolver()` Get the namespace resolver to supply the namespace context of the instruction that is being traced
`int` `getObjectNameCode()` Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
`Iterator` `getProperties()` Get an iterator over all the properties available.
`Object` `getProperty(String name)` Get a named property of the instruction
`String` `getPublicId()` Get the public ID of the module containing the instruction.
`String` `getSystemId()` Get the URI of the module containing the instruction
`String` `getSystemId(int locationId)` Get the URI of the document or module containing a particular location
`void` `setColumnNumber(int column)` Set the column number
`void` `setConstructType(int type)` Set the type of construct
`void` `setLineNumber(int lineNumber)` Set the line number of the instruction within the module
`void` `setNamespaceResolver(NamespaceResolver resolver)` Set the namespace context for the instruction being traced.
`void` `setObjectNameCode(int nameCode)` Set a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
`void` `setProperty(String name, Object value)` Set a named property of the instruction
`void` `setSystemId(String systemId)` Set the URI of the module containing the instruction

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InstructionDetails

    public InstructionDetails()

Method Detail

### setConstructType

    public void setConstructType(int type)

  Set the type of construct

### getConstructType

    public int getConstructType()

  Get the construct type

  Specified by:
    `getConstructType` in interface `InstructionInfo`

### setNamespaceResolver

    public void setNamespaceResolver(NamespaceResolver resolver)

  Set the namespace context for the instruction being traced. This is needed if the tracelistener wants to evaluate XPath expressions in the context of the current instruction

### getNamespaceResolver

    public NamespaceResolver getNamespaceResolver()

  Get the namespace resolver to supply the namespace context of the instruction that is being traced

  Specified by:
    `getNamespaceResolver` in interface `InstructionInfo`

### setSystemId

    public void setSystemId(String systemId)

  Set the URI of the module containing the instruction

  Parameters:
    `systemId` - the module's URI

### getSystemId

    public String getSystemId()

  Get the URI of the module containing the instruction

  Specified by:
    `getSystemId` in interface `SourceLocator`
  Specified by:
    `getSystemId` in interface `InstructionInfo`
  Specified by:
    `getSystemId` in interface `Locator`
  Returns:
    the module's URI

### setLineNumber

    public void setLineNumber(int lineNumber)

  Set the line number of the instruction within the module

  Parameters:
    `lineNumber` - the line number

### getLineNumber

    public int getLineNumber()

  Get the line number of the instruction within its module

  Specified by:
    `getLineNumber` in interface `SourceLocator`
  Specified by:
    `getLineNumber` in interface `InstructionInfo`
  Specified by:
    `getLineNumber` in interface `Locator`
  Returns:
    the line number

### setObjectNameCode

    public void setObjectNameCode(int nameCode)

  Set a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.

### getObjectNameCode

    public int getObjectNameCode()

  Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.

  Specified by:
    `getObjectNameCode` in interface `InstructionInfo`

### setProperty

    public void setProperty(String name,
                            Object value)

  Set a named property of the instruction

### getProperty

    public Object getProperty(String name)

  Get a named property of the instruction

  Specified by:
    `getProperty` in interface `InstructionInfo`
  Parameters:
    `name` - The name of the required property
  Returns:
    The value of the requested property, or null if the property is not available

### getProperties

    public Iterator getProperties()

  Get an iterator over all the properties available. The values returned by the iterator will be of type String, and each string can be supplied as input to the getProperty() method to retrieve the value of the property.

  Specified by:
    `getProperties` in interface `InstructionInfo`

### getPublicId

    public String getPublicId()

  Get the public ID of the module containing the instruction. This method is provided to satisfy the SourceLocator interface. However, the public ID is not maintained by Saxon, and the method always returns null

  Specified by:
    `getPublicId` in interface `SourceLocator`
  Specified by:
    `getPublicId` in interface `Locator`
  Returns:
    null

### setColumnNumber

    public void setColumnNumber(int column)

  Set the column number

### getColumnNumber

    public int getColumnNumber()

  Get the column number identifying the position of the instruction.

  Specified by:
    `getColumnNumber` in interface `SourceLocator`
  Specified by:
    `getColumnNumber` in interface `Locator`
  Returns:
    -1 if column number is not known

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Get the InstructionInfo details about the construct. This is to satisfy the InstructionInfoProvider interface.

  Specified by:
    `getInstructionInfo` in interface `InstructionInfoProvider`

### getSystemId

    public String getSystemId(int locationId)

  Description copied from interface: `LocationProvider`
  Get the URI of the document or module containing a particular location

  Specified by:
    `getSystemId` in interface `LocationProvider`
  Parameters:
    `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
  Returns:
    the URI of the document or module.

### getLineNumber

    public int getLineNumber(int locationId)

  Description copied from interface: `LocationProvider`
  Get the line number within the document or module containing a particular location

  Specified by:
    `getLineNumber` in interface `LocationProvider`
  Parameters:
    `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
  Returns:
    the line number within the document or module.

Copyright (C) Michael H. Kay. All rights reserved.